function InventarioRotativoDecorator(ZHPromise, PreRequests) {

    /*
     * Decorator do Inventário Rotativo. Valida toda abertura de telas,
     * impedindo que aquelas que validam estoque sejam abertas caso haja
     * inventário rotativo pendente, assim como nos sistemas Delphi.
     */
    this.apply = function(containerName, container) {
        if (container.validaEstoque === true) {
            // PreRequests.setContainerBeingValidated();
            var deferred = ZHPromise.defer();
            PreRequests.validaInventarioRotativo(container).then(function(resolve) {
                var inventarioValido = resolve.inventarioValido;
                var container = resolve.container;
                var inveRotaContainer = (containerName === "est#ger03302_inventario_rotativo");
                if (inventarioValido !== inveRotaContainer) {
                    container.events = container.events || [];
                    container.events.push({
                        name: "ContainerAfterinit",
                        code: "PreRequests.validaInventarioRotativo(args.owner)"
                    });
                }
            }).finally(function() {
                deferred.resolve(container);
            });
            return deferred.promise;
        }
        else {
            return container;
        }
    };
}